# rpp2xml (reaper to nuendo xml)
# made by 2ZS
# email 6370736@gmail.com
# donate PayPal.Me/6370
# version 0.1
# Best regard)))
'''
Now it include many steps before run script, but with time I do it simple  with only runing script from proj.
Tested in win.


1 you needs installed python 3.7.2 and make setting in reaper
2 only audio items in project; audio 24/48, placed in one folder(use it in all applications next steps)
3 unmute all items save as edl sampletude
4 undo unmute, save rpp
5 open in sampletude and export to aaf(audio not include in single file)
6 import aaf in nuendo and export to xml (export selected track)

You hove: all events with  position, lenght, volume, track name, ... (from sampletude aaf)



7 place the .xml in the same folder with .rpp and rename it to “EXPORT.xml”
8 run script
9 wait
Done!)))




Now the script adds:
1 rename events to names of active items
2 mute events as items(aaf from sampletude delete muted items)
3 item volume envelope to env by pencil tool nuendo
4 color items (from my reaper color set (my toolbar and my color Set needs install))
5 type of crossfade (equal gain or equal power)(test)




'''




from reaper_python import *
import os


import sys
import xml.etree.cElementTree as etree
from xml.dom import minidom


#(ReaProject proj, String buf, Int buf_sz) 
(RP, Bf, Bfs)= RPR_GetProjectName(0, "", 512)
#path=bf[1]

#(String buf, Int buf_sz) 
(Bf2,Bfs2) = RPR_GetProjectPath("", 512)



try:
  #tree = etree.parse('/Users/Oleg/Documents/Rpp2XML_PY/EXPORT.xml')
  tree = etree.parse(Bf2+"/EXPORT.xml")
except:
  tree = etree.parse(Bf2+"\EXPORT.xml")


root = tree.getroot()  
root 

fgh=''
#t=0
#i=0
iiii=0
myvolenv=0
mymute=0
mycolor=0
myname=0
myfadeoutshape=0
myfadeinshape=0






cTrack = RPR_CountTracks(0)
#itemsPerTrack = []
for tTrack in range(0, cTrack):
  MediaTrack = RPR_GetTrack(0, tTrack)
  #itemsPerTrack.append(RPR_CountTrackMediaItems(tTrack))#spisok kol-vo items per track
  cItem = RPR_CountTrackMediaItems(MediaTrack)
  #cItem = RPR_CountMediaItems(0)
  for iItem in range (0, cItem):
        iiii+=1
        MediaItem = RPR_GetTrackMediaItem(MediaTrack, iItem)
        #MediaItem = RPR_GetMediaItem(0, iItem) #tTrack????????????
        #MediaTrack = RPR_GetTrack(0, t) # choose t track
        #MediaItem = RPR_GetMediaItem(MediaTrack, i) # choose i item, t track
        #MediaItem = RPR_GetSelectedMediaItem(0,0)
        #tTrack = RPR_GetMediaItem_Track(MediaItem)    
        #NAME=RPR_GetTakeName(MediaItem_Take)
        ITEM_MUTE = RPR_GetMediaItemInfo_Value(MediaItem, "B_MUTE")
        ITEM_VOL = RPR_GetMediaItemInfo_Value(MediaItem, "D_VOL")
        ITEM_POSITION = RPR_GetMediaItemInfo_Value(MediaItem, "D_POSITION")
        ITEM_LENGTH = RPR_GetMediaItemInfo_Value(MediaItem, "D_LENGTH")
        ITEM_SNAPOFFSET = RPR_GetMediaItemInfo_Value(MediaItem, "D_SNAPOFFSET")
        ITEM_FADEINLEN = RPR_GetMediaItemInfo_Value(MediaItem, "D_FADEINLEN")
        ITEM_FADEOUTLEN = RPR_GetMediaItemInfo_Value(MediaItem, "D_FADEOUTLEN")
        ITEM_FADEINLEN_AUTO = RPR_GetMediaItemInfo_Value(MediaItem, "D_FADEINLEN_AUTO")
        ITEM_FADEOUTLEN_AUTO = RPR_GetMediaItemInfo_Value(MediaItem, "D_FADEOUTLEN_AUTO")
        ITEM_FADEINSHAPE =  RPR_GetMediaItemInfo_Value(MediaItem, "C_FADEINSHAPE") # int * to fadein shape, 0=linear, ...
        ITEM_FADEOUTSHAPE =  RPR_GetMediaItemInfo_Value(MediaItem, "C_FADEOUTSHAPE") # int * to fadeout shape
        ITEM_CUSTOMCOLOR = RPR_GetMediaItemInfo_Value(MediaItem, "I_CUSTOMCOLOR")
        ITEM_CURTAKE = RPR_GetMediaItemInfo_Value(MediaItem, "I_CURTAKE")
        ITEM_ITEMNUMBER =  RPR_GetMediaItemInfo_Value(MediaItem, "IP_ITEMNUMBER") #number per track
        MediaItem_Take = RPR_GetTake(MediaItem, int(ITEM_CURTAKE))
        TAKE_STARTOFFS = RPR_GetMediaItemTakeInfo_Value(MediaItem_Take, "D_STARTOFFS") #position in file
        TAKE_NAME = RPR_GetTakeName(MediaItem_Take)
        SOURCE = RPR_GetMediaItemTakeInfo_Value(MediaItem_Take, "P_SOURCE")
        PCM_source = RPR_GetMediaItemTake_Source(MediaItem_Take)
        PCM_sourceRoot = RPR_GetMediaSourceParent(PCM_source) #0 if in media root 
        PCM_source_array = RPR_GetMediaSourceFileName(PCM_source, "", 512)
        TAKE_PATH_FILENAME = PCM_source_array[1]
        #!!!!!!win po drugomu!!!!!!!!
        
        try:
          TAKE_PATH,TAKE_FILENAM = TAKE_PATH_FILENAME.rsplit("/",1) 
          TAKE_PATH+="/"
        except ValueError:
          TAKE_PATH,TAKE_FILENAM = TAKE_PATH_FILENAME.rsplit("\\",1) 
          TAKE_PATH+="\\"
           
        MediaSourceLength = RPR_GetMediaSourceLength(PCM_source,0)
        MEDIA_SOURCE_LENGHT = MediaSourceLength[0]
        TakeEnvelope = RPR_GetTakeEnvelopeByName(MediaItem_Take, "Volume")
        #Int = RPR_GetEnvelopePointByTimeEx(TrackEnvelope,3, 0)
        env_points_count = RPR_CountEnvelopePoints(TakeEnvelope)
        
        #if TakeEnvelope and env_points_count == -1: 
        #fgh += str(iItem)+" "

        trackN = tTrack#1 - (1)
        tracks = root [0]#n track
        events = tracks[trackN][3][2]
        event = events[iItem] #n event
        
        
        
        def expfade (sr):
           newElement = etree.Element('item')
           fl0=etree.SubElement(newElement, 'float', {'value': str(sr/2)}, name = "X")
           fl1=etree.SubElement(newElement, 'float', {'value':'0.70710678118654757'}, name = "Y")
           return newElement
#########################################################################################################        
        if ITEM_FADEINSHAPE == 7:
          myfadeinshape+=1
          try:            
                         a = event.attrib ["value"]
                         #print (event)
                         #print (event.attrib) 
                         evs = (root.findall(".//obj[@ID='" + str(a)+"'][@class='MAudioEvent']"))
                         for ev in evs[0]:
                            #print (ev)
                            #print (ev.attrib)
                            #print('1')
                            if ev.attrib ['name'] == 'FadeIn':
                               try:
                                  bb = ev.attrib ['class'] 
                                  ev[0].attrib ["class"] = "MEqualPowerInterpolator"
                                  sr = float(ev[0][0][1][0].attrib ['value'])              
                                  newElement = expfade(sr)
                                  ev[0][0].append(newElement)
                                  ev[0][0][2], ev[0][0][1] = ev[0][0][1], ev[0][0][2]
                               except KeyError:
                                  b = ev.attrib ['ID']
                                  ev2 = (root.findall(".//obj[@ID='" + str(b)+"'][@class='MFadeIn']"))
                                  #print(ev2[0].attrib)
                                  ev2[0][0].attrib ["class"] = "MEqualPowerInterpolator"
                                  sr = float(ev2[0][0][0][1][0].attrib ['value'])
                                  newElement = expfade(sr)
                                  ev2[0][0][0].append(newElement)
                                  ev2[0][0][0][2], ev2[0][0][0][1] = ev2[0][0][0][1], ev2[0][0][0][2]                                     
          except KeyError:        
                         #print('2')
                         for ev in event:
                            #print (ev)
                            #print (ev.attrib) 
                            if ev.attrib ['name'] == 'FadeIn':
                               try:
                                  bb = ev.attrib ['class'] 
                                  ev[0].attrib ["class"] = "MEqualPowerInterpolator"
                                  sr = float(ev[0][0][1][0].attrib ['value'])
                                  newElement = expfade(sr)
                                  ev[0][0].append(newElement)
                                  ev[0][0][2], ev[0][0][1] = ev[0][0][1], ev[0][0][2]
                               except KeyError:
                                  b = ev.attrib ['ID']
                                  ev2 = (root.findall(".//obj[@ID='" + str(b)+"'][@class='MFadeIn']"))
                                  #print(ev2[0].attrib)
                                  ev2[0][0].attrib ["class"] = "MEqualPowerInterpolator"
                                  sr = float(ev2[0][0][0][1][0].attrib ['value'])
                                  newElement = expfade(sr)
                                  ev2[0][0][0].append(newElement)
                                  ev2[0][0][0][2], ev2[0][0][0][1] = ev2[0][0][0][1], ev2[0][0][0][2]  
          
          

###############################################
        if ITEM_FADEOUTSHAPE == 7:
          myfadeoutshape+=1
          try: 
                                  a = event.attrib ["value"]
                                  #print (event)
                                  #print (event.attrib) 
                                  evs = (root.findall(".//obj[@ID='" + str(a)+"'][@class='MAudioEvent']"))
                                  for ev in evs[0]:
                                     #print (ev)
                                     #print (ev.attrib)
                                     #print('1')
                                     if ev.attrib ['name'] == 'FadeOut':
                                        try:
                                           bb = ev.attrib ['class'] 
                                           ev[0].attrib ["class"] = "MEqualPowerInterpolator"
                                           sr = float(ev[0][0][1][0].attrib ['value'])              
                                           newElement = expfade(sr)
                                           ev[0][0].append(newElement)
                                           ev[0][0][2], ev[0][0][1] = ev[0][0][1], ev[0][0][2]
                                        except KeyError:
                                           b = ev.attrib ['ID']
                                           ev2 = (root.findall(".//obj[@ID='" + str(b)+"'][@class='MFadeOut']"))
                                           #print(ev2[0].attrib)
                                           ev2[0][0].attrib ["class"] = "MEqualPowerInterpolator"
                                           sr = float(ev2[0][0][0][1][0].attrib ['value'])
                                           newElement = expfade(sr)
                                           ev2[0][0][0].append(newElement)
                                           ev2[0][0][0][2], ev2[0][0][0][1] = ev2[0][0][0][1], ev2[0][0][0][2]                                     
          except KeyError:         
                   
                                  #print('2')
                                  for ev in event:
                                     #print (ev)
                                     #print (ev.attrib) 
                                     if ev.attrib ['name'] == 'FadeOut':
                                        try:
                                           bb = ev.attrib ['class'] 
                                           ev[0].attrib ["class"] = "MEqualPowerInterpolator"
                                           sr = float(ev[0][0][1][0].attrib ['value'])
                                           newElement = expfade(sr)
                                           ev[0][0].append(newElement)
                                           ev[0][0][2], ev[0][0][1] = ev[0][0][1], ev[0][0][2]
                                        except KeyError:
                                           b = ev.attrib ['ID']
                                           ev2 = (root.findall(".//obj[@ID='" + str(b)+"'][@class='MFadeOut']"))
                                           #print(ev2[0].attrib)
                                           ev2[0][0].attrib ["class"] = "MEqualPowerInterpolator"
                                           sr = float(ev2[0][0][0][1][0].attrib ['value'])
                                           newElement = expfade(sr)
                                           ev2[0][0][0].append(newElement)
                                           ev2[0][0][0][2], ev2[0][0][0][1] = ev2[0][0][0][1], ev2[0][0][0][2]

###########################################################################################
        try:
                         myname+=1
                         a = event.attrib ["value"]
                         #print (event)
                         #print (event.attrib) 
                         evs = (root.findall(".//obj[@ID='" + str(a)+"'][@class='MAudioEvent']"))
                         for ev in evs[0]:
                          if (ev.tag =='string' and ev.attrib ['name']=='Description'): 
                            ev.attrib ["value"] = TAKE_NAME 
        except KeyError:
                         #print (event)
                         #print (event.attrib)  
                         for ev in event:
                          if (ev.tag =='string' and ev.attrib ['name']=='Description'): 
                            ev.attrib ["value"] = TAKE_NAME   

###########################################################################################################

        if ITEM_CUSTOMCOLOR > 0:
          mycolor+=1
          def colorR2N(colorR):
            if   colorR == 16777471: ColorN = "0"      #red pc
            elif colorR == 16810239: ColorN = "1"      #orange pc
            elif colorR == 16842751: ColorN = "3"      #yellow  pc
            elif colorR == 25198847: ColorN = "14"     #pink pc
            elif colorR == 33519872: ColorN = "9"      #blue pc
            elif colorR == 16825633: ColorN = "5"      #green pc
            elif colorR == 28569088: ColorN = "7"      #berjuzovyy pc

            elif colorR == 33488896: ColorN = "0"      #red mac
            elif colorR == 33521664: ColorN = "1"      #o  mac
            elif colorR == 33554176: ColorN = "3"      #y mac
            elif colorR == 33521792: ColorN = "14"     #p mac
            elif colorR == 16808447: ColorN = "9"      #blue mac
            elif colorR == 19119360: ColorN = "5"      #green mac
            elif colorR == 16838582: ColorN = "7"      #berjuzovyy mac
 
     
            else: ColorN = "12"
            return ColorN

          def addColor():
                """add color to add atrib 
                """
                newElement = etree.Element('int', {'value': str(colorR2N(ITEM_CUSTOMCOLOR))}, name = "Farb")                
                return newElement
          def addColorAddAtr():
                """ass add atr and color to add atrib 
                """
                newElement = etree.Element('member', name="Additional Attributes")
                ob = etree.SubElement(newElement, 'int', {'value': str(colorR2N(ITEM_CUSTOMCOLOR))}, name = "Farb")                
                return newElement
          
              
          try:
                   a = event.attrib ["value"]
                   #print (event)
                   #print (event.attrib)
                   IDD = (root.findall(".//member/obj[@ID='" + str(a)+"']"))
                   for dd in IDD:
                      try:
                         dd.attrib ["class"]
                         #print (dd.attrib)
                         addAtr = 0
                         for childDD in dd:
                            if childDD.attrib ["name"] == 'Additional Attributes':
                               #print(childDD.attrib)
                               newElement = addColor()
                               childDD.append(newElement)
                               #print(eee,"1.1")
                               #print (prettify(childDD[1]))
                               addAtr = 1
                         if not addAtr:                               
                            newElement = addColorAddAtr()
                            dd.append(newElement)
                            #print(eee,"1.2")
                            #childDD.append(etree.fromstring(prettify(newElement)))
                            #print (prettify(childDD[0]))
                      except KeyError:
                         b = dd.attrib ["ID"]
                         IDDD = (root.findall(".//obj[@ID='" + str(b)+"'][@class='MAudioEvent']"))
                         for ddd in IDDD:
                            #print (ddd.attrib)
                            addAtr = 0
                            for dddd in ddd:
                               if (dddd.attrib ["name"] == 'Additional Attributes'):
                                  #print(dddd.attrib)
                                  newElement = addColor()
                                  dddd.append(newElement)
                                  #print(eee,"2.1")
                                  #print (prettify(dddd[1]))
                                  addAtr = 1
                            if not addAtr:                                 
                               newElement = addColorAddAtr()
                               ddd.append(newElement)
                               #print(eee,"2.2")
                               #dddd.append(etree.fromstring(prettify(newElement)))
                               #print (prettify(dddd[0]))               
          except KeyError:
                   #print (event)
                   #print (event.attrib)
                   addAtr = 0
                   for child in event:
                      #print(child.attrib)
                      #print(child)
                      if child.attrib ["name"] ==  'Additional Attributes':
                         #print(child.attrib)
                         newElement = addColor()
                         child.append(newElement)
                         #print(eee,"3.1")
                         #print(prettify(child[1]))
                         addAtr = 1
                   if not addAtr:
                      addAtr = 0   
                      newElement = addColorAddAtr()
                      event.append(newElement)
                      #print(eee, "3.2")
                      #child.append(newElement)
                      #child.append(etree.fromstring(prettify(newElement)))
                      #print (prettify(child))
         

        if ITEM_MUTE==1:
          mymute+=1
          try:
                 a = event.attrib ["value"]
                 #print (event)
                 #print (event.attrib)
                 IDD = (root.findall(".//member/obj[@ID='" + str(a)+"']"))
                 for dd in IDD:
                    try:
                       dd.attrib ["class"]
                       #print (dd.attrib) 
                       newElement = newElement = etree.Element('int', {'value':'2'}, name = "Flags")
                       dd[0].append(newElement)                          
                    except KeyError:
                       b = dd.attrib ["ID"]
                       IDDD = (root.findall(".//obj[@ID='" + str(b)+"'][@class='MAudioEvent']"))
                       for ddd in IDDD:
                          #print (ddd.attrib) 
                          newElement = etree.Element('int', {'value':'2'}, name = "Flags")
                          ddd.append(newElement)          
          except KeyError:
                 #print (event)
                 #print (event.attrib) 
                 newElement = etree.Element('int', {'value':'2'}, name = "Flags")
                 event[0].append(newElement)                       
                                   

        if TakeEnvelope and env_points_count > 0:
          myvolenv+=1
          pointsReaperT = []
          pointsReaperV = []
          pointsReaper = []
          for pc in range (0,env_points_count):
            #env_retval = RPR_GetEnvelopePoint(TrackEnvelope,pc,0,0,0,0,0)[0]
            #env_TrackEnvelope = RPR_GetEnvelopePoint(TrackEnvelope,pc,0,0,0,0,0)[1]
            #env_ptidx = RPR_GetEnvelopePoint(TrackEnvelope,pc,0,0,0,0,0)[2]
            env_timeOutOptional = RPR_GetEnvelopePoint(TakeEnvelope,pc,0,0,0,0,0)[3]
            env_valueOutOptional = RPR_GetEnvelopePoint(TakeEnvelope,pc,0,0,0,0,0)[4] * 2
            #env_shapeOutOptional = RPR_GetEnvelopePoint(TrackEnvelope,pc,0,0,0,0,0)[5]
            #env_tensionOutOptional = RPR_GetEnvelopePoint(TrackEnvelope,pc,0,0,0,0,0)[6]
            #env_selectedOutOptional = RPR_GetEnvelopePoint(TrackEnvelope,pc,0,0,0,0,0)[7]
            pointsReaperT.append(str((env_timeOutOptional+TAKE_STARTOFFS)*48000))
            pointsReaperV.append(str(env_valueOutOptional/2))
          pointsReaper = list(zip(pointsReaperT,pointsReaperV))
         
          def point():
                """add mlinear points to add atrib 
                """
                newElement = etree.Element('obj', {'class':'MLinearInterpolator'}, name = "VlCv", ID = "410170984")
                li = etree.SubElement(newElement, 'list', {'type':'list'}, name = "Points")
                it = etree.SubElement(li, 'item')
                fl0 = etree.SubElement(it, 'float', {'value': '0'}, name="X")
                fl1 = etree.SubElement(it, 'float', {'value':str(pointsReaper[0][1])}, name = "Y")
                for pointReaper in pointsReaper:
                      it=etree.SubElement(li, 'item')
                      fl0=etree.SubElement(it, 'float', {'value': str(pointReaper[0])}, name="X")
                      fl1=etree.SubElement(it, 'float', {'value':str(pointReaper[1])}, name="Y")
                it=etree.SubElement(li, 'item')
                fl0=etree.SubElement(it, 'float', {'value': str(MEDIA_SOURCE_LENGHT * 48000)}, name="X")
                fl1=etree.SubElement(it, 'float', {'value':str(pointsReaper[-1][1])}, name="Y")
                li=etree.SubElement(newElement, 'float', {'value':'0'}, name="XMin")
                li=etree.SubElement(newElement, 'float', {'value': str(MEDIA_SOURCE_LENGHT*48000)}, name="XMax")
                li=etree.SubElement(newElement, 'float', {'value':'0'}, name="YMin")
                li=etree.SubElement(newElement, 'float', {'value':'1'}, name="YMax")
                return newElement
          def addAtrPoint():
                """ass add atr and add mlinear points to add atrib 
                """
                newElement = etree.Element('member', name="Additional Attributes")
                ob = etree.SubElement(newElement, 'obj', {'class':'MLinearInterpolator'}, name="VlCv", ID="410170984")
                li=etree.SubElement(ob, 'list', {'type':'list'}, name="Points")
                it=etree.SubElement(li, 'item')
                fl0=etree.SubElement(it, 'float', {'value': '0'}, name="X")
                fl1=etree.SubElement(it, 'float', {'value':str(pointsReaper[0][1])}, name="Y")
                for pointReaper in pointsReaper:
                      it=etree.SubElement(li, 'item')
                      fl0=etree.SubElement(it, 'float', {'value': str(pointReaper[0])}, name="X")
                      fl1=etree.SubElement(it, 'float', {'value':str(pointReaper[1])}, name="Y")
                it=etree.SubElement(li, 'item')
                fl0=etree.SubElement(it, 'float', {'value': str(MEDIA_SOURCE_LENGHT*48000)}, name="X")
                fl1=etree.SubElement(it, 'float', {'value':str(pointsReaper[-1][1])}, name="Y")
                li=etree.SubElement(ob, 'float', {'value':'0'}, name="XMin")
                li=etree.SubElement(ob, 'float', {'value': str(MEDIA_SOURCE_LENGHT*48000)}, name="XMax")
                li=etree.SubElement(ob, 'float', {'value':'0'}, name="YMin")
                li=etree.SubElement(ob, 'float', {'value':'1'}, name="YMax")
                return newElement
          try:
                 a = event.attrib ["value"]
                 #print (event)
                 #print (event.attrib)
                 IDD = (root.findall(".//member/obj[@ID='" + str(a)+"']"))
                 for dd in IDD:
                    try:
                       dd.attrib ["class"]
                       #print (dd.attrib)
                       addAtr = 0
                       for childDD in dd:
                          if childDD.attrib ["name"] == 'Additional Attributes':
                             #print(childDD.attrib)
                             newElement = point()
                             childDD.append(newElement)
                             #print(eee,"1.1")
                             #print (prettify(childDD[1]))
                             addAtr = 1
                       if not addAtr:
                          addAtr = 0   
                          newElement = addAtrPoint()
                          dd.append(newElement)
                          #print(eee,"1.2")
                          #childDD.append(etree.fromstring(prettify(newElement)))
                          #print (prettify(childDD[0]))
                    except KeyError:
                       b = dd.attrib ["ID"]
                       IDDD = (root.findall(".//obj[@ID='" + str(b)+"'][@class='MAudioEvent']"))
                       for ddd in IDDD:
                          #print (ddd.attrib)
                          addAtr = 0
                          for dddd in ddd:
                             if (dddd.attrib ["name"] == 'Additional Attributes'):
                                #print(dddd.attrib)
                                newElement = point()
                                dddd.append(newElement)
                                #print(eee,"2.1")
                                #print (prettify(dddd[1]))
                                addAtr = 1
                          if not addAtr:
                             addAtr = 0   
                             newElement = addAtrPoint()
                             ddd.append(newElement)
                             #print(eee,"2.2")
                             #dddd.append(etree.fromstring(prettify(newElement)))
                             #print (prettify(dddd[0]))               
          except KeyError:
                 #print (event)
                 #print (event.attrib)
                 addAtr = 0
                 for child in event:
                    #print(child.attrib)
                    #print(child)
                    if child.attrib ["name"] ==  'Additional Attributes':
                       #print(child.attrib)
                       newElement = point()
                       child.append(newElement)
                       #print(eee,"3.1")
                       #print(prettify(child[1]))
                       addAtr = 1
                 if not addAtr:
                    addAtr = 0   
                    newElement = addAtrPoint()
                    event.append(newElement)
                    #print(eee, "3.2")
                    #child.append(newElement)
                    #child.append(etree.fromstring(prettify(newElement)))
                    #print (prettify(child))
try: 
  tree.write(Bf2+"/EXPORT_scripted.xml")
except:
  tree.write(Bf2+"\EXPORT_scripted.xml")

RPR_ShowConsoleMsg("Done!")

print("myvolenv=",myvolenv, ' ',
"mymute=",mymute, ' ',
"mycolor=",mycolor, ' ',
"myname=",myname, ' ',
"myfadeoutshape=",myfadeoutshape, ' ',
"myfadeinshape=",myfadeinshape, ' ')   
